
(setq *AXIOMS* 
   '(
     ((next-to <box.1-axiom1> <box.2-axiom1>) .
			      ((inroom <box.1-axiom1> <room.axiom1>)
			       (inroom <box.2-axiom1> <room.axiom1>)))
     ((next-to robot <box.axiom2>) . ((inroom <box.axiom2> <room.axiom2>)
				      (inroom robot <room.axiom2>)))
     ((next-to robot <key.axiom3>) . ((inroom <key.axiom3> <room.axiom3>)
				      (inroom robot <room.axiom3>)))
     ((next-to robot <door.axiom4>) . 
                                ((connects <door.axiom4> <room.x4> <room.y4>)
				 (inroom robot <room.y4>)))
     ((dr-open <door.axiom5>) . ((unlocked <door.axiom5>)))
     ((locked <door.axiom6>) . ((dr-closed <door.axiom6>)))
;     ((holding <box.axiom7>) . ((inroom <box.axiom7> <room.axiom7>)
;                                (connects <door.axiom7> <room.x7> <room.axiom7>)
;				(inroom robot <room.axiom7>)
;				(carriable <box.axiom7>)))
;     ((holding <key.axiom8>) . ((inroom <key.axiom8> <room.axiom8>)
;                                (connects <door.axiom8> <room.x8> <room.axiom8>)
;				(inroom robot <room.axiom8>)
;				(carriable <key.axiom8>)))
     ((~ (dr-open <door.axiom9>)) . ((dr-closed <door.axiom9>)))
     ((~ (dr-closed <door.axiom10>)) . ((dr-open <door.axiom10>)
				      (unlocked <door.axiom10>)))
     ((~ (locked <door.axiom11>)) . ((unlocked <door.axiom11>)))
     ((~ (unlocked <door.axiom12>)) . ((locked <door.axiom12>)
				     (dr-closed <door.axiom12>)))
     ((~ (arm-empty)) . ((holding <box.o13>)(holding <key.o13>)))
     ((~ (holding <box.axiom14>)) . ((arm-empty)))
     ((~ (holding <key.axiom15>)) . ((arm-empty)))
     ))

(setq *VARIABLE-EXPANSION* nil)
(setq *VARIABLE-TYPING* '(
			  (isa 'object 'type)
			  (isa 'box 'object)
			  (isa 'key 'object)
			  (isa 'door 'object)
			  (isa 'robot 'type)
			  (isa 'room 'type)
			  (isa-instance 'robot 'robot)
			  (isa-instance 'box1 'box)
			  (isa-instance 'box2 'box)
			  (isa-instance 'box3 'box)
			  (isa-instance 'runi 'room)
			  (isa-instance 'rmys 'room)
			  (isa-instance 'rram 'room)
			  (isa-instance 'rhal 'room)
			  (isa-instance 'rpdp 'room)
			  (isa-instance 'rclk 'room)
			  (isa-instance 'rril 'room)
			  (isa-instance 'dunimys 'door)
			  (isa-instance 'dmysram 'door)
			  (isa-instance 'dramhal 'door)
			  (isa-instance 'dmyspdp 'door)
			  (isa-instance 'dpdpclk 'door)
			  (isa-instance 'dmysclk 'door)
			  (isa-instance 'dramclk 'door) 
			  (isa-instance 'dclkril 'door)
			  (isa-instance 'unimys-key 'key)
			  (isa-instance 'mysram-key 'key)
			  (isa-instance 'ramhal-key 'key)
			  (isa-instance 'myspdp-key 'key)
			  (isa-instance 'pdpclk-key 'key)
			  (isa-instance 'mysclk-key 'key)
			  (isa-instance 'ramclk-key 'key) 
			  (isa-instance 'clkril-key 'key)

			  ; For run1.lisp
			  (isa-instance 'rm1 'room)
			  (isa-instance 'rm2 'room)
			  (isa-instance 'dr12 'door)
			  (isa-instance 'key12 'key)

			  ; For run2.lisp
			  (isa-instance 'rm3 'room)
			  (isa-instance 'rm4 'room)
			  (isa-instance 'dr23 'door)
			  (isa-instance 'dr34 'door)
			  (isa-instance 'key23 'key)
			  (isa-instance 'key34 'key)
			  
			  ; For run3.lisp
			  (isa-instance 'hall 'room)
			  (isa-instance 'kitch 'room)
			  (isa-instance 'droom 'room)
			  (isa-instance 'lroom 'room)
			  (isa-instance 'bath 'room)
			  (isa-instance 'den 'room)
			  (isa-instance 'dr-kitch-droom 'door)
			  (isa-instance 'dr-hall-kitch 'door)
			  (isa-instance 'dr-lroom-droom 'door)
			  (isa-instance 'dr-den-droom 'door)
			  (isa-instance 'dr-den-kitch 'door)
			  (isa-instance 'dr-den-bath 'door)
			  (isa-instance 'A 'box)
			  (isa-instance 'B 'box)
			  (isa-instance 'C 'box)
			  (isa-instance 'D 'box)
			  (isa-instance 'E 'box)
			  (isa-instance 'F 'box)
			  (isa-instance 'G 'box)
			  (isa-instance 'H 'box)
			  (isa-instance 'I 'box)
			  (isa-instance 'J 'box)
			  (isa-instance 'den-key 'key)
			  (isa-instance 'bath-key 'key)
			  ))

(setq *PRIMARY* '(
   ((holding <box>) . (PICKUP-BOX))
   ((holding <key>) . (PICKUP-KEY))
   ((arm-empty) . (PUTDOWN-BOX PUTDOWN-KEY))
   ((next-to <box.1> <box.2>) . (PUTDOWN-BOX-NEXT-TO PUSH-BOX))
   ((next-to <box> <door>) . (PUSH-BOX-TO-DR))
   ((inroom <box> <room>) . (PUSH-BOX-THRU-DR CARRY-BOX-THRU-DR))
   ((inroom robot <room>) . (GO-THRU-DR))
   ((inroom <key> <room>) . (CARRY-KEY-THRU-DR))
   ((next-to robot <door>) . (GOTO-DR))
   ((next-to robot <box>) . (GOTO-BOX))
   ((next-to robot <key>) . (GOTO-KEY))
   ((dr-open <door>) . (OPEN))
   ((dr-closed <door>). (CLOSE))
   ((locked <door>) . (LOCK))
   ((unlocked <door>) . (UNLOCK))
		  ))


;(setq *AT-LEAST-ONE-GENERATORS*
;       '((inroom t nil)))   ; Every object is in at least one room.


(setq *SINGLE-HIERARCHY* nil)